var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import cx from 'clsx';
import { Checkbox } from "./..";
import { DropdownMultiItemWrapper, DropdownItem, DropdownListWrapper, DropdownWrapper, DropdownDivider, DropdownTriggerWrapper, DropdownListOverflowWrapper, } from './styles';
import { DropdownTrigger } from './DropdownTrigger';
export var Dropdown = function (_a) {
    var children = _a.children, outRef = _a.outRef, className = _a.className, trigger = _a.trigger, dropup = _a.dropup, fluid = _a.fluid, open = _a.open, rest = __rest(_a, ["children", "outRef", "className", "trigger", "dropup", "fluid", "open"]);
    return (React.createElement(DropdownWrapper, { className: cx(className, { open: open }), fluid: fluid, ref: outRef },
        trigger ? (trigger()) : (React.createElement(Dropdown.Trigger, __assign({ open: open, dropup: dropup }, rest))),
        open && children));
};
Dropdown.Trigger = DropdownTrigger;
Dropdown.TriggerWrapper = DropdownTriggerWrapper;
Dropdown.Divider = DropdownDivider;
Dropdown.ListWrapper = function (_a) {
    var _b = _a.maxHeight, maxHeight = _b === void 0 ? '204px' : _b, // 6 standard items;
    _c = _a.direction, // 6 standard items;
    direction = _c === void 0 ? 'right' : _c, rounded = _a.rounded, dropup = _a.dropup, autoWidth = _a.autoWidth, _d = _a.offset, offset = _d === void 0 ? '0' : _d, noBorder = _a.noBorder, children = _a.children;
    return (React.createElement(DropdownListWrapper, { direction: direction, rounded: rounded, dropup: dropup, autoWidth: autoWidth, offset: offset, noBorder: noBorder },
        React.createElement(DropdownListOverflowWrapper, { maxHeight: maxHeight }, children)));
};
Dropdown.Item = function (_a) {
    var children = _a.children, rest = __rest(_a, ["children"]);
    return (React.createElement(DropdownItem, __assign({}, rest), children));
};
Dropdown.Checkbox = function (_a) {
    var children = _a.children, checked = _a.checked, _b = _a.color, color = _b === void 0 ? 'primary' : _b, inheritColor = _a.inheritColor;
    return (React.createElement(DropdownMultiItemWrapper, null,
        children,
        React.createElement(Checkbox, { checked: checked, color: color, inheritColor: inheritColor, tabIndex: -1 })));
};
