import { getParticipantIds, getReviewerIds, isOwner, isParticipantInReview, isReviewer, } from './session';
export var CONTINUE_TEACHING = 'Continue Teaching';
export var CONTINUE_CONVERSION = 'Continue Conversion';
export var START_TEACHING = 'Start Teaching';
export var START_CONVERSION = 'Start Conversion';
export var VIEW = 'View';
export var REVIEW = 'Review';
export var START_REVIEW = 'Start Review';
export var getSessionButtonText = function (session, sme, currentUserId) {
    if (sme === void 0) { sme = false; }
    var archived = session.archived, teachingOwnerId = session.teachingOwnerId, conversionOwnerId = session.conversionOwnerId, handedOver = session.handedOver;
    var reviewerIds = getReviewerIds(sme, session);
    var participantIds = getParticipantIds(sme, session);
    var owner = isOwner(sme, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewer = isReviewer(currentUserId, reviewerIds);
    var participant = isParticipantInReview(currentUserId, participantIds);
    if (archived || (sme && handedOver)) {
        return VIEW;
    }
    if (owner) {
        return sme ? CONTINUE_TEACHING : CONTINUE_CONVERSION;
    }
    if (reviewer) {
        return participant ? REVIEW : START_REVIEW;
    }
    if (!teachingOwnerId && !conversionOwnerId) {
        return START_TEACHING;
    }
    if (!sme && !conversionOwnerId) {
        return START_CONVERSION;
    }
    return VIEW;
};
